zoukankan      html  css  js  c++  java
  • codeforces#302div2_D 暴力bfs求最短路,图论

    codeforces#302div2_D 暴力bfs求最短路,图论

    D. Destroying Roads
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    In some country there are exactly n cities and m bidirectional roads connecting the cities. Cities are numbered with integers from 1 to n. If cities a and b are connected by a road, then in an hour you can go along this road either from city a to city b, or from city b to city a. The road network is such that from any city you can get to any other one by moving along the roads.

    You want to destroy the largest possible number of roads in the country so that the remaining roads would allow you to get from city s1to city t1 in at most l1 hours and get from city s2 to city t2 in at most l2 hours.

    Determine what maximum number of roads you need to destroy in order to meet the condition of your plan. If it is impossible to reach the desired result, print -1.

    Input

    The first line contains two integers nm (1 ≤ n ≤ 3000, ) — the number of cities and roads in the country, respectively.

    Next m lines contain the descriptions of the roads as pairs of integers aibi (1 ≤ ai, bi ≤ nai ≠ bi). It is guaranteed that the roads that are given in the description can transport you from any city to any other one. It is guaranteed that each pair of cities has at most one road between them.

    The last two lines contains three integers each, s1, t1, l1 and s2, t2, l2, respectively (1 ≤ si, ti ≤ n0 ≤ li ≤ n).

    Output

    Print a single number — the answer to the problem. If the it is impossible to meet the conditions, print -1.

    Sample test(s)
    input
    5 4
    1 2
    2 3
    3 4
    4 5
    1 3 2
    3 5 2
    output
    0
    input
    5 4
    1 2
    2 3
    3 4
    4 5
    1 3 2
    2 4 2
    output
    1
    input
    5 4
    1 2
    2 3
    3 4
    4 5
    1 3 2
    3 5 1
    output
    -1

    题意:给定一个无向无权图,给定s1,t1,l1;s2,t2,l2;,求去掉最多的边数,使得剩下的图能保证s1到t1的距离小于l1,s2到t2的距离小于l2;
    思路: 先bfs暴力出所有的最短路dist[i][j],时间复杂度o(n^2);
        只保留s1,t1和s2,t2经过的边,其它边都可去除。分两种情况:
    1,两条路径不交叉,显然ans=m-(d1+d2);
       2,两条路径有重叠部分,显然这两条路径必定是H形,重叠部分为dist[i][j];
          暴力出符合条件的i和j,取最优解;
        *注意暴力时s1,t1和s2,t2反向的情况,需交换s1,t1,再暴力一次,防止跳过最优解。
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #include<cstdlib>
    #include<algorithm>
    #include<vector>
    #include<queue>
    
    using namespace std;
    
    const int maxn=3100;
    const int INF=(1<<29);
    typedef long long ll;
    
    int n,m;
    int dist[maxn][maxn];
    vector<int> G[maxn];
    int s1,t1,l1;
    int s2,t2,l2;
    bool vis[maxn];
    struct Node
    {
        int x,step;
    };
    
    void bfs(int s)
    {
        memset(vis,0,sizeof(vis));
        queue<Node> q;
        q.push({s,0});
        vis[s]=1;
        while(!q.empty()){
            Node now=q.front();
            int u=now.x;
            dist[s][u]=now.step;
            q.pop();
            for(int i=0;i<(int)G[u].size();i++){
                int v=G[u][i];
                if(!vis[v]){
                    q.push({v,now.step+1});
                    vis[v]=1;
                }
            }
        }
    }
    
    int main()
    {
        while(cin>>n>>m){
            for(int i=1;i<=n;i++) G[i].clear();
            for(int i=1;i<=m;i++){
                int u,v;
                scanf("%d%d",&u,&v);
                G[u].push_back(v);
                G[v].push_back(u);
            }
            for(int i=1;i<=n;i++){
                for(int j=1;j<=n;j++){
                    if(i==j) dist[i][j]=0;
                    else dist[i][j]=INF;
                }
            }
            for(int i=1;i<=n;i++) bfs(i);
            cin>>s1>>t1>>l1>>s2>>t2>>l2;
            int d=INF;
            for(int it=0;it<2;it++){
                swap(s1,t1);
                for(int i=1;i<=n;i++){
                    for(int j=1;j<=n;j++){
                        int d1=dist[s1][i]+dist[i][j]+dist[j][t1];
                        int d2=dist[s2][i]+dist[i][j]+dist[j][t2];
                        if(d1<=l1&&d2<=l2){
                            if(d1+d2-dist[i][j]<d) d=d1+d2-dist[i][j];
                        }
                    }
                }
            }
            if(dist[s1][t1]+dist[s2][t2]<d&&dist[s1][t1]<=l1&&dist[s2][t2]<=l2) d=dist[s1][t1]+dist[s2][t2];
            if(m-d<0) cout<<-1<<endl;
            else cout<<m-d<<endl;
        }
        return 0;
    }
    View Code


    没有AC不了的题,只有不努力的ACMER!
  • 相关阅读:
    mysql复制那点事
    全排列问题
    56. Merge Interval
    2. Add Two Numbers
    20. Valid Parentheses
    121. Best Time to Buy and Sell Stock
    120. Triangle
    96. Unique Binary Search Trees
    91. Decode Ways
    72. Edit Distance
  • 原文地址:https://www.cnblogs.com/--560/p/4498833.html
Copyright © 2011-2022 走看看